// $Id: bzv.js 3508 2010-04-29 13:16:34Z anton $
// $URL: https://svn.non-gnu.uvt.nl/uvt-dev/tags/sources/meresco/bzv-8.6.3/html/static/bzv.js $
//
// Provide the XMLHttpRequest class for IE 5.x-6.x:
// RESOURCE = http://en.wikipedia.org/wiki/XMLHttpRequest
// More information from http://www.w3.org/TR/XMLHttpRequest/
function makeArray(arrayName){
    if (this.container[arrayName] == null)
	this.container[arrayName] = new Array();
    return this.container[arrayName];
}

function HashContainer(){
    this.container = [];
    this.make = makeArray;
}

if(typeof XMLHttpRequest == "undefined") XMLHttpRequest = function() {
  try { return new ActiveXObject("Msxml2.XMLHTTP.6.0") } catch(e) {}
  try { return new ActiveXObject("Msxml2.XMLHTTP.3.0") } catch(e) {}
  try { return new ActiveXObject("Msxml2.XMLHTTP") } catch(e) {}
  try { return new ActiveXObject("Microsoft.XMLHTTP") } catch(e) {}
  throw new Error("This browser does not support XMLHttpRequest.")
};

// N.B. Configuration is generated in pageheader.sf
function readSysconfig(javaConfig){
    var decoded = Base64.decode (javaConfig);
    var sysconfig = '';
    sysconfig = YAHOO.lang.JSON.parse(decoded);
    return sysconfig
}

function onLoad(javaConfig){
    initFocus();

    YAHOO.util.Event.onDOMReady(function () {
	var userFeedbackNodes = YAHOO.util.Dom.getElementsByClassName('userFeedback');
	var userFeedbackLocation = document.getElementById ('searchTips');

//  FIXME, dit werkt niet goed voor IE, daar zullen we wel innerhtml voor moeten gebruiken of zo.
//  Het basisidee werkt wel: zet foutmeldingen voortaan op één vaste plek op het scherm.

/*
	for (var i = 0; i < userFeedbackNodes.length; i ++){
	    var firstChild = userFeedbackLocation.firstChild;

	    var text = userFeedbackNodes.innerHTML;
	    var cloned = document.createElement("div");

	    var li = document.createElement("li");
	    YAHOO.util.Dom.addClass(cloned,"userFeedback");

	    li.appendChild(cloned);
	    YAHOO.util.Dom.insertBefore(li, firstChild);
	}
*/
        for (var i = 0; i < userFeedbackNodes.length; i ++){
            var firstChild = userFeedbackLocation.firstChild;

            var cloned = clone(userFeedbackNodes[ i ]);
            var li = document.createElement("li");
            cloned.setAttribute("style","display:block");

            li.appendChild(cloned);
            YAHOO.util.Dom.insertBefore(li, firstChild);
        }
    });

}

function inDepot(callNumber){
    var inDepot = false
    for (var i in cf.depotCollectionList){
        if (callNumber.indexOf(cf.depotCollectionList[i]) == 0){
            inDepot = true;
            for(var j in cf.depotExceptionList){
                if (callNumber.indexOf(cf.depotExceptionList[j]) == 0){
                    inDepot = false;
                    break;
                }
            }
            if (inDepot) return true;
        }
    }
    return false;
}

function initFocus(){
    var el = document.getElementById('searchQuery');
    if (typeof(el) != "undefined")
	if (el) el.focus();
}

function extractData(record) {
    var data = new Object();
    var fields = record.childNodes;
    var numFields = fields.length;
    for(var j = 0; j < numFields; j++) {
        var field = fields[j];
        if(!field.tagName) continue;
        if(field.childNodes && field.childNodes[0])
            data[field.tagName] = field.childNodes[0].nodeValue;
    }
    return data;
}

function createLinkDiv(url, displayText, imageBoolean){
    if (cf.pub[displayText]) displayText = cf.pub[displayText];
    var divNode = document.createElement("div");
    if (imageBoolean){
	var imageNode = document.createElement("img");
	imageNode.setAttribute("src", "/files/edoc.gif");
	imageNode.setAttribute("alt", "*");
	divNode.appendChild(imageNode);
    }
    var linkNode = document.createElement("a");
    linkNode.setAttribute("href", url);
    linkNode.setAttribute("target", "_blank");
    linkNode.appendChild(document.createTextNode(displayText));
    divNode.appendChild(linkNode);
    return divNode;
}

function createDepotRequest(db, location, displayText) {
    var url = "http://dbiref.uvt.nl/iPort?request=full_record&db=" + db +
        "&searchField=sgn&query=" + location;
    return createLinkDiv(url, displayText, false);
}

function translate(key) {
    if (key == null) return '';

    var value =  cf.translateHash[key.toLowerCase()];
    if (!value) value = key;

    return value;
}

function processLocatorInfo(o, genre, nodeHash){
    var rootNode = o.responseXML.documentElement;
    var records = rootNode.childNodes;
    var numRecords = records.length;
    for(var i = 0; i < numRecords; i++) {
        var record = records[i];
        if(!record.tagName || record.tagName != 'record') continue;
        processRecordWithLocatorInfo(record, genre, nodeHash);
    }
}



function processRecordWithLocatorInfo(record, genre, nodeHash ){
    var locInfo = extractData(record);
    var url = locInfo.generatedUrl;

    if (url && url.indexOf('://') != -1){
        var image = true;
        var group = "linkmethod";
        if (locInfo.linkMethod == 'ILL'){
            image = false;
            group = "ill";
	}

	var linkText = locInfo.methodName?locInfo.methodName:translate(locInfo.linkMethod);
	nodeHash.make(group).push(createLinkDiv(url, linkText, image));
    }
    else {
        callNumber = locInfo.callNumber;
        if (genre == "article"){
            if (callNumber.indexOf('T ') == 0 || callNumber.indexOf('TF ') == 0){
                // this test is to filter non-journals; however there are call number for books that start with "TF "
                // this problem will be solved when full-journal-title searching is implemented
                var col = locInfo.collection;
                // FIXME: config
                if (col == "ECO" ||
                    col == "JUR" || col == "SOC" || col == "LET" || col == "CIF" ||
		    col == "TFL" || col == "BRA" || col == "GES" || col == "DISC") {
			nodeHash.make('inlibrary').push(document.createTextNode(callNumber + " (" + col + ")"));
                    }
                else if (col) {
                    // test met:
                    // ?recordId=RePEc-kap-pubcho:oai:RePEc:kap:pubcho:v:110:y:2002:i:3-4:p:327-50
                    var url = "http://dbiref.uvt.nl/iPort?request=full_record&db=tuts&searchField=sgn&query=" + callNumber;
		    nodeHash.make('indepot').push(createLinkDiv(url, callNumber, false));
                }
            }
        }
        else {
            if (callNumber) {
                processRecordWithCirculationInfo(record, genre, nodeHash);
            }
        }
    }
}

function processRecordWithCirculationInfo(record, genre, nodeHash){
    var locInfo = extractData(record);
    var db = "tucat";
    if (genre == "journal") db = "tuts";
    var status = locInfo.status;
    var callNumber = locInfo.callNumber;

    // copy of inzage
    if (status == 'i' || status == 'f'){
        displayText = callNumber + " (not for loan)"
        if (inDepot(callNumber))
	    nodeHash.make('indepot').push(createDepotRequest(db, callNumber, displayText));
        else

            nodeHash.make('inlibrary').push(document.createTextNode(displayText));
        return;
    }

    var availStatus = record.getElementsByTagName("dlf:availabilitystatus");
    if (availStatus.length > 0){
        availability = availStatus[0].childNodes[0].nodeValue;
        if (availability == 'available') {
            if (inDepot(callNumber))
                nodeHash.make('indepot').push(createDepotRequest(db, callNumber, callNumber));
            else
                nodeHash.make('inlibrary').push(document.createTextNode(callNumber));
        }
        else if (availability == 'not available'){
           var url = "http://dbiref.uvt.nl/iPort?request=full_record&db=" + db +
               "&searchField=sgn&query=" + callNumber;
           nodeHash.make('onloan').push(createLinkDiv(url, callNumber, false));
        }
        else if (availability == 'unknown'){
           var url = "http://dbiref.uvt.nl/iPort?request=full_record&db=" + db +
               "&searchField=sgn&query=" + callNumber;
           nodeHash.make('moreinfo').push(createLinkDiv(url, callNumber, false));
       }
    }
    else if (callNumber){
        var url = "http://dbiref.uvt.nl/iPort?request=full_record&db=" + db +
            "&searchField=sgn&query=" + callNumber;
        nodeHash.make('moreinfo').push(createLinkDiv(url, callNumber, false));
    }
    else if (locInfo.linkMethod = 'ILL')
        nodeHash.make('ill').push(createLinkDiv(locInfo.generatedUrl, locInfo.linkMethod, false));
}

function processCirculationInfo(o, genre, nodeHash ){
   var rootNode = o.responseXML.documentElement;
   var records = rootNode.childNodes;
   var numRecords = records.length;
   for(var i = 0; i < numRecords; i++) {
       var record = records[i];
       if (record.tagName && record.tagName == 'record')
           processRecordWithCirculationInfo(record, genre, nodeHash );
   }
}

function presentAvailability(node, o, openurl, location) {
    var query = openurl.split("?")[1];
    var pairs = query.split("&");
    var genre = ""
    for (var i=0; i < pairs.length; i++) {
        var pair = pairs[i].split("=");
        if (pair[0] == "genre") {
            genre = pair[1];
        }
    }

    var nodeHash = new HashContainer();

    if (!location){
        processLocatorInfo(o, genre, nodeHash);
    }
    else {
        processCirculationInfo(o, genre, nodeHash);
    }

// wo-tilburguniversity-nl:oai:wo.uvt.nl:3583585

    for (var group in cf.availabilityGroups ){

        if (nodeHash.container[group] != null){
            var titleNode = document.createElement("li");
            YAHOO.util.Dom.addClass(titleNode, "title");
            titleNode.appendChild(document.createTextNode(cf.availabilityGroups[group]));
            node.appendChild(titleNode);

            for (var link in nodeHash.container[group]){
                var liNode = document.createElement("li");
                liNode.appendChild(nodeHash.container[group][link]);
                node.appendChild(liNode);
	    }
        }
    }
}

function fixXml4Chrome(o){
    if ((o.responseXML == null) && (o.responseText.length > 0))  {
	var parser=new DOMParser();
	var responseXML = parser.parseFromString(o.responseText,"text/xml");
	o.responseXML = responseXML;
    }
}


function openurl(nodeid, openurl){
    var node = document.getElementById(nodeid);

    function successHandler(o) {
	fixXml4Chrome(o);
	presentAvailability(node, o, openurl, "");
    }

    function failureHandler(o)
    {
	/*
	if (console)
	    console.error('Meresco:openurl XMLHttpRequest statusText: ' + o.statusText);
	*/
	node.appendChild(document.createTextNode("Locator unavailable"));
    }

    var request = YAHOO.util.Connect.asyncRequest('GET', openurl, {
	    success:successHandler,
	    failure:failureHandler,
	    timeout: 15000
	});
}

function availability(nodeid, location, inDepot, genre, openurl){
    var node = document.getElementById(nodeid);
    // console.log("nodeid:'" + nodeid + "'");

    function successHandler(o) {
	fixXml4Chrome(o);
        presentAvailability(node, o, openurl, location);
    }

    function failureHandler(o)
    {
	/*
	if (console)
	    console.error('Meresco:availability XMLHttpRequest statusText: ' + o.statusText);
	*/
	node.appendChild(document.createTextNode("No availability information"));
    }

    var request = YAHOO.util.Connect.asyncRequest('GET', openurl, {
	    success:successHandler,
	    failure:failureHandler,
	    timeout: 15000
	});
}

// searchForm stuff
function relocateKeepDrilldown(drilldown){
    var searchQuery = document.getElementById('searchQuery');

    var extra='';
    if (location.pathname == '/'){
	extra = 'search';
    }
    var newLocation = extra + "?query=" + encodeURIComponent(searchQuery.value);

    if (drilldown){
	newLocation += drilldown;
    }

    var sortKeys = document.getElementById('sortKeys');
	newLocation += "&sortKeys=" + sortKeys.value;

    top.location = newLocation;
    return false;
}

function relocateKeepQuery(obj){
    var searchQuery = getElementById('searchQuery');
    var newQuery = "?query=" + encodeURIComponent(searchQuery.value);
    var newLocation = newQuery + '&' + obj.value ;
    top.location= newLocation;
}

function relocateKeepQueryHref(query){
	//debugger;
    var searchQuery = document.getElementById('searchQuery');
    var newQuery = "?query=" + encodeURIComponent(searchQuery.value);
    var newLocation = newQuery + '&' + query
    top.location= newLocation;
    return false;
}

function clearSearch(){
    var l=top.location;
    var port=l.port;
    if (l.port)
	port=":"+port;

    top.location=l.protocol + "//" + l.hostname + port + "/search?query=";
}

// YAHOO stuff
modules  = new Array();

function clone(node) {

    var tagName = node.tagName;
    var nodeValue = node.nodeValue;

    if(tagName) {
	var cln = document.createElement(tagName);

	var att = node.attributes;
	for(var i = 0; i < att.length; i++){
	    if (att[i].name == 'class')
		YAHOO.util.Dom.addClass(cln, att[i].value);
	    else
		cln.setAttribute(att[i].name, att[i].value);
	}

	var chi = node.childNodes;
	for(var i = 0; i < chi.length; i++)
	    cln.appendChild(clone(chi[i]));

	return cln;
    } else if(nodeValue) {
	return document.createTextNode(nodeValue);
    }
}

function extractRecord(xmlDoc) {
    var rootNode = xmlDoc.documentElement;

    if(rootNode.nodeName=='parsererror') {
	//if (console)
	//    console.error(rootNode.firstChild.nodeValue);
    }

    var data = new Array();
    var fields = rootNode.childNodes;

    for(var i = 0; i < fields.length; i++) {
        var field = fields[i];

        if(!field.tagName || field.tagName != 'field')
            continue;

	var datum = new Object();

        var fieldElements = field.childNodes;
        for(var j = 0; j < fieldElements.length; j++) {
            var fieldElement = fieldElements[j];
	    var tagName = fieldElement.tagName;

           if(!tagName)
                continue;

            if(tagName == 'label')
		datum.label = fieldElement.childNodes[0].nodeValue;
	    else
		datum.content = fieldElement;
        }
	data.push(datum);
    }
    return data;
}


function presentData(dataArray, widget, index) {
    var tableNode = document.getElementById('table'+index);
    // Cleanup previous results
    while (tableNode.firstChild) {
	tableNode.removeChild(tableNode.firstChild);
    }

    // DO NOT use e.setAttribute("class", "classname");
    // because IE will ignore the call completely.
    // In stead use:
    // YAHOO.util.Dom.addClass(tableNode, "recordElementTable");
    // For IE 'tbody' is required
    // IE needs tr and td elements mere divs are invisible
    //
    //var tBodyNode  = document.createElement('tbody');
    //YAHOO.util.Dom.addClass(tBodyNode, "recordElementTableBody");
    var collect='';

    for(var i = 0; i < dataArray.length ; i++) {
        var field =              dataArray[i];
        var rowNode =            document.createElement('div');

	var className = field.label;
	className = className.replace(/[\s\W]*/g,"");

	YAHOO.util.Dom.addClass(rowNode, className);

        var thLabelNode = document.createElement('div');
	YAHOO.util.Dom.addClass(thLabelNode, "label");

        var tdContentNode = document.createElement('div');
	YAHOO.util.Dom.addClass(tdContentNode,"value");

	thLabelNode.appendChild(document.createTextNode(field.label));
	rowNode.appendChild(thLabelNode);

	var childNodes = field.content.childNodes;
	for(var j = 0; j < childNodes.length; j++) {

	    if(childNodes[j]) {
		var chi = clone(childNodes[j]);
		tdContentNode.appendChild(chi);
	    }
	}
	rowNode.appendChild(tdContentNode);
	//tBodyNode.appendChild(rowNode);
	//tableNode.appendChild(tBodyNode);
	tableNode.appendChild(rowNode);
    }
}


function getContent(widget,recordId,index)
{
    function successHandler(o) {
	fixXml4Chrome(o);
        var data = extractRecord(o.responseXML);
        presentData(data, widget, index);
    }

    function failureHandler(o) {
        var widgetNode=document.getElementById("content"+index);
	YAHOO.util.Dom.addClass(widgetNode,"recordElementContentError");
        widget.setBody("Record information could not be retrieved: "+o.statusText);
    }

    var request = YAHOO.util.Connect.asyncRequest('GET',"/record?recordId="+recordId, {
            success:successHandler,
            failure:failureHandler,
            timeout: 15000
        });
}

function singleRecordDetails(index, recordId){
    YAHOO.util.Event.onDOMReady(function () {
        modules[index]=new Array();
        modules[index].widget=new YAHOO.widget.Module("content"+index, { visible: true });

        getContent(modules[index].widget,recordId,index);
        modules[index].widget.render();
	});
}

function generateMoreinfoToggler(index, buttonPreName, recordId){
    var more = translate("showDetails");
    var less = translate("hideDetails");

    YAHOO.util.Event.onDOMReady(function () {
            modules[index]=new Array();
            modules[index].button =
                new YAHOO.widget.Button({ type: "checkbox",
					  label: more,
					  id: "checkbutton"+index, name: "checkboxfield"+index,
					  value: "1",
					  container: "moduleContainer"+index, checked: false });

	    modules[index].button.set('class','button');
            modules[index].widget=new YAHOO.widget.Module("content"+index, { visible: false });
            modules[index].widget.render();

            function onCheckedChange(e) {
                if (e.newValue) {
                    modules[index].button.set('label',less);
                    getContent(modules[index].widget,recordId,index);
                    modules[index].widget.show();
                } else {
                    modules[index].widget.hide();
                    modules[index].button.set('label',more);
                }
                modules[index].widget.render();
            }
            modules[index].button.addListener("checkedChange", onCheckedChange);

	});
}

// errorImg MUST meet the specified criteria to prevent eternal loop
function onImageLoaded(img, errorImg)
{
    if ( img.naturalWidth < cf.minCoverWidth ){
	img.src = errorImg;
    }
    return true;
}

// errorImg MUST ALWAYS BE PRESENT to prevent eternal loop
function onImageError(img, errorImg)
{

// This works in Chrome only :)
    var parentNode = img.parentNode;
    var grandParentNode = parentNode.parentNode;
    grandParentNode.appendChild(img);
    grandParentNode.removeChild(parentNode);

    img.src = errorImg;
    return true;
}

function morelessFacets(moreless, label){
    var hide = 'chopped-';
    var show = 'full-';
    if (moreless == translate('less')){
	hide = 'full-';
	show = 'chopped-'
    }
    var obj  =  widgetNode=document.getElementById(hide + label);
    obj.style.display='none';
    obj  =  widgetNode=document.getElementById(show + label);
    obj.style.display='block';
}

////////////////////////////////////////
/**
*  FIXME: find a standard library somewhere.
*
*  Base64 decode
*  http://www.webtoolkit.info/
*
**/
var Base64 = {
    // private property
    _keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",

    // public method for decoding
    decode : function (input) {
	var output = "";
	var chr1, chr2, chr3;
	var enc1, enc2, enc3, enc4;
	var i = 0;

	input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

	while (i < input.length) {
	    enc1 = this._keyStr.indexOf(input.charAt(i++));
	    enc2 = this._keyStr.indexOf(input.charAt(i++));
	    enc3 = this._keyStr.indexOf(input.charAt(i++));
	    enc4 = this._keyStr.indexOf(input.charAt(i++));

	    chr1 = (enc1 << 2) | (enc2 >> 4);
	    chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
	    chr3 = ((enc3 & 3) << 6) | enc4;

	    output = output + String.fromCharCode(chr1);

	    if (enc3 != 64) {
		output = output + String.fromCharCode(chr2);
	    }
	    if (enc4 != 64) {
		output = output + String.fromCharCode(chr3);
	    }
	}
	output = Base64._utf8_decode(output);
	return output;

    },
    // private method for UTF-8 decoding
    _utf8_decode : function (utftext) {
	var string = "";
	var i = 0;
	var c = c1 = c2 = 0;
	while (i < utftext.length) {
	    c = utftext.charCodeAt(i);

	    if (c < 128) {
		string += String.fromCharCode(c);
		i++;
	    }
	    else if((c > 191) && (c < 224)) {
		c2 = utftext.charCodeAt(i+1);
		string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
		i += 2;
	    }
	    else {
		c2 = utftext.charCodeAt(i+1);
		c3 = utftext.charCodeAt(i+2);
		string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
		i += 3;
	    }
	}
	return string;
    }
}

