# $Id: composefulljournaltitlefrommods.py 2964 2010-01-25 13:29:53Z anton $
# $URL: https://svn.non-gnu.uvt.nl/uvt-dev/tags/sources/meresco/bzv-8.6.3/src/composefulljournaltitlefrommods.py $
from merescocore.framework import Observable

class ComposeFullJournalTitleFromMods(Observable):
    def __init__(self, fieldName):
        Observable.__init__(self)
        self._namespaceMap = {'mods':'http://www.loc.gov/mods/v3'}
        self._fieldName = fieldName

    def add(self, id, partName, lxmlNode):
        genre = lxmlNode.xpath('//mods:mods/mods:genre/text()', self._namespaceMap)
        title = lxmlNode.xpath('//mods:mods/mods:titleInfo/mods:title/text()', self._namespaceMap)
        if genre and title:
            if genre[0] == "journal":
                title = title[0].lstrip().lower()
                partition = title.partition(' ')
                firstword = partition[0]
                if firstword in ['the', 'de', 'het', 'le', 'la', 'der', 'die', 'das']:
                    title = partition[2]
                title = title.partition(':')[0]
                yield self.all.addField(name=self._fieldName, value=title)
